﻿using Buddy.Wildstar.Game;
using log4net;

namespace Agility
{
    static class VariableController
    {
        private static ILog Log = LogManager.GetLogger("Agility [VariableController]");
        private static bool FacingLock, AlwaysFaceTarget, MoveToTarget, DoubleTapDash, ShowDoubleTapDash, ButtonDown;

        public static void SaveSettings()
        {
            Log.Debug("Saving original combat settings.");

            FacingLock          = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('player.disableFacingLock')");
            AlwaysFaceTarget    = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('player.ignoreAlwaysFaceTarget')");
            MoveToTarget        = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('player.moveToTargetOnSelfAOE')");
            //DoubleTapDash       = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('player.doubleTapToDash')");
            //ShowDoubleTapDash   = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('player.showDoubleTapToDash')");

            ButtonDown          = GameManager.Lua.GetReturnValue<bool>("return Apollo.GetConsoleVariable('spell.useButtonDownForAbilities')");
        }

        public static void LoadPreferredSettings()
        {
            Log.Debug("Loading preferred combat settings.");

            SpellManager.SetSpellCastingBehavior(SpellCastingBehavior.Normal);

            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.disableFacingLock', true)");
            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.ignoreAlwaysFaceTarget', true)");
            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.moveToTargetOnSelfAOE', false)");
            //GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.doubleTapToDash', true)");
            //GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.showDoubleTapToDash', true)");

            GameManager.Lua.DoString("Apollo.SetConsoleVariable('spell.useButtonDownForAbilities', false)");
        }

        public static void ResetSettings()
        {
            Log.Debug("Reverting back to original combat settings.");

            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.disableFacingLock', " + FacingLock.ToString().ToLower() + ")");
            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.ignoreAlwaysFaceTarget', " + AlwaysFaceTarget.ToString().ToLower() + ")");
            GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.moveToTargetOnSelfAOE', " + MoveToTarget.ToString().ToLower() + ")");
            //GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.doubleTapToDash', " + DoubleTapDash.ToString().ToLower() + ")");
            //GameManager.Lua.DoString("Apollo.SetConsoleVariable('player.showDoubleTapToDash', " + ShowDoubleTapDash.ToString().ToLower() + ")");

            GameManager.Lua.DoString("Apollo.SetConsoleVariable('spell.useButtonDownForAbilities', " + ButtonDown.ToString().ToLower() + ")");
        }
    }
}
