﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Warrior_Default : IAgilityRoutine
    {
        // Routine Info.
        public string Name { get { return "Default"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }
        public Class Class { get { return Class.Warrior; } }

        // Custom Methods.
        private Player Me { get { return GameManager.LocalPlayer; } }

        // Routine.
        public string Routine()
        {
            // NOPEs.
            if (Me.CurrentCast != null && Me.CurrentCast.Name == "Whirlwind")
                return null;

            #region Gadgets

            #region Gadget: Absorb
            if (SpellController.CanCast("Absorb"))
                return "Absorb";
            #endregion

            #region Gadget: Barrier
            if (SpellController.CanCast("Barrier"))
                return "Barrier";
            #endregion

            #region Gadget: Bellow
            if (SpellController.CanCast("Bellow"))
                return "Bellow";
            #endregion

            #region Gadget: Berserk
            if (SpellController.CanCast("Berserk"))
                return "Berserk";
            #endregion

            #region Gadget: Bloodscent
            if (SpellController.CanCast("Bloodscent"))
                return "Bloodscent";
            #endregion

            #region Gadget: Break
            if (SpellController.CanCast("Break"))
                return "Break";
            #endregion

            #region Gadget: Break Free
            if (SpellController.CanCast("Break Free"))
                return "Break Free";
            #endregion

            #region Gadget: Burly
            if (SpellController.CanCast("Burly"))
                return "Burly";
            #endregion

            #region Gadget: Buffer
            if (SpellController.CanCast("Buffer"))
                return "Buffer";
            #endregion

            #region Gadget: Cleanse
            if (SpellController.CanCast("Cleanse"))
                return "Cleanse";
            #endregion

            #region Gadget: Cruelty
            if (SpellController.CanCast("Cruelty"))
                return "Cruelty";
            #endregion

            #region Gadget: Defender
            if (SpellController.CanCast("Defender"))
                return "Defender";
            #endregion

            #region Gadget: Destruction
            if (SpellController.CanCast("Destruction"))
                return "Destruction";
            #endregion

            #region Gadget: Dodger
            if (SpellController.CanCast("Dodger"))
                return "Dodger";
            #endregion

            #region Gadget: Disabler
            if (SpellController.CanCast("Disabler"))
                return "Disabler";
            #endregion

            #region Gadget: Disintegrate
            if (SpellController.CanCast("Disintegrate"))
                return "Disintegrate";
            #endregion

            #region Gadget: Dissolve
            if (SpellController.CanCast("Dissolve"))
                return "Dissolve";
            #endregion

            #region Gadget: E.M.P.
            if (SpellController.CanCast("E.M.P."))
                return "E.M.P.";
            #endregion

            #region Gadget: Encase
            if (SpellController.CanCast("Encase"))
                return "Encase";
            #endregion

            #region Gadget: Erudite
            if (SpellController.CanCast("Erudite"))
                return "Erudite";
            #endregion

            #region Gadget: Exodus Sands
            if (SpellController.CanCast("Exodus Sands"))
                return "Exodus Sands";
            #endregion

            #region Gadget: Ferocity
            if (SpellController.CanCast("Ferocity"))
                return "Ferocity";
            #endregion

            #region Gadget: Finesse
            if (SpellController.CanCast("Finesse"))
                return "Finesse";
            #endregion

            #region Gadget: Fortitude
            if (SpellController.CanCast("Fortitude"))
                return "Fortitude";
            #endregion

            #region Gadget: Giant's Growth
            if (SpellController.CanCast("Giant's Growth"))
                return "Giant's Growth";
            #endregion

            #region Gadget: Guard
            if (SpellController.CanCast("Guard"))
                return "Guard";
            #endregion

            #region Gadget: Guiding Light
            if (SpellController.CanCast("Guiding Light"))
                return "Guiding Light";
            #endregion

            #region Gadget: Heal
            if (SpellController.CanCast("Heal"))
                return "Heal";
            #endregion

            #region Gadget: Healer's Gift
            if (SpellController.CanCast("Healer's Gift"))
                return "Healer's Gift";
            #endregion

            #region Gadget: Intensity
            if (SpellController.CanCast("Intensity"))
                return "Intensity";
            #endregion

            #region Gadget: Juggernaut
            if (SpellController.CanCast("Juggernaut"))
                return "Juggernaut";
            #endregion

            #region Gadget: Mirage Relic
            if (SpellController.CanCast("Mirage Relic"))
                return "Mirage Relic";
            #endregion

            #region Gadget: Mist of the Oasis
            if (SpellController.CanCast("Mist of the Oasis"))
                return "Mist of the Oasis";
            #endregion

            #region Gadget: Parry
            if (SpellController.CanCast("Parry"))
                return "Parry";
            #endregion

            #region Gadget: Power
            if (SpellController.CanCast("Power"))
                return "Power";
            #endregion

            #region Gadget: Power Reserves
            if (SpellController.CanCast("Power Reserves"))
                return "Power Reserves";
            #endregion

            #region Gadget: Powerup
            if (SpellController.CanCast("Powerup"))
                return "Powerup";
            #endregion

            #region Gadget: Punisher
            if (SpellController.CanCast("Punisher"))
                return "Punisher";
            #endregion

            #region Gadget: Precision
            if (SpellController.CanCast("Precision"))
                return "Precision";
            #endregion

            #region Gadget: Protection
            if (SpellController.CanCast("Protection"))
                return "Protection";
            #endregion

            #region Gadget: Protection of the Voidstriker
            if (SpellController.CanCast("Protection of the Voidstriker"))
                return "Protection of the Voidstriker";
            #endregion

            #region Gadget: Pursuant
            if (SpellController.CanCast("Pursuant"))
                return "Pursuant";
            #endregion

            #region Gadget: Rally
            if (SpellController.CanCast("Rally"))
                return "Rally";
            #endregion

            #region Gadget: Recovery
            if (SpellController.CanCast("Recovery"))
                return "Recovery";
            #endregion

            #region Gadget: Reinforce
            if (SpellController.CanCast("Reinforce"))
                return "Reinforce";
            #endregion

            #region Gadget: Replenish
            if (SpellController.CanCast("Replenish"))
                return "Replenish";
            #endregion

            #region Gadget: Reserves
            if (SpellController.CanCast("Reserves"))
                return "Reserves";
            #endregion

            #region Gadget: Salvation
            if (SpellController.CanCast("Salvation"))
                return "Salvation";
            #endregion

            #region Gadget: Savagery
            if (SpellController.CanCast("Savagery"))
                return "Savagery";
            #endregion

            #region Gadget: Second Wind
            if (SpellController.CanCast("Second Wind"))
                return "Second Wind";
            #endregion

            #region Gadget: Severity
            if (SpellController.CanCast("Severity"))
                return "Severity";
            #endregion

            #region Gadget: Shield Charge
            if (SpellController.CanCast("Shield Charge"))
                return "Shield Charge";
            #endregion

            #region Gadget: Shredder
            if (SpellController.CanCast("Shredder"))
                return "Shredder";
            #endregion

            #region Gadget: Stasis
            if (SpellController.CanCast("Stasis"))
                return "Stasis";
            #endregion

            #region Gadget: Tenacity
            if (SpellController.CanCast("Tenacity"))
                return "Tenacity";
            #endregion

            #region Gadget: True Strike
            if (SpellController.CanCast("True Strike"))
                return "True Strike";
            #endregion

            #region Gadget: Unbreakable
            if (SpellController.CanCast("Unbreakable"))
                return "Unbreakable";
            #endregion

            #region Gadget: Unleash
            if (SpellController.CanCast("Unleash"))
                return "Unleash";
            #endregion

            #region Gadget: Vanish
            if (SpellController.CanCast("Vanish"))
                return "Vanish";
            #endregion

            #region Gadget: Wisdom
            if (SpellController.CanCast("Wisdom"))
                return "Wisdom";
            #endregion

            #endregion

            #region Abilities

            #region Power Link
            if (SpellController.CanCast("Power Link") && Me.InnateResource >= 350 && SpellController.BuffCount("Power Link") == 0)
                return "Power Link";
            #endregion

            #region Augmented Blade
            // Augmented Blade Aura Management.
            if (SpellController.CanCast("Augmented Blade"))
            {
                // Augmented Blade -> OFF.
                if (Me.HasBuff("Augmented Blade"))
                {
                    // Kinetic Fury AMP / Low Fury.
                    if (SpellController.HasAMP("Kinetic Fury") && Me.InnateResource < 750)
                        return "Augmented Blade";

                    // Too many stacks.
                    else if (SpellController.BuffCount("Kinetic Drain: Augmented Blade") >= 8)
                        return "Augmented Blade";
                }

                // Augmented Blade -> ON.
                else if (SpellController.BuffCount("Kinetic Drain: Augmented Blade") == 0)
                {
                    // Kinetic Fury AMP / High Fury.
                    if (SpellController.HasAMP("Kinetic Fury") && Me.InnateResource >= 750)
                        return "Augmented Blade";

                    // No Kinetic Fury, might as well.
                    else if (SpellController.HasAMP("Kinetic Fury") && Me.InnateResource >= 500)
                        return "Augmented Blade";

                    // No Kinetic Fury, might as well.
                    //else if (!SpellController.HasAMP("Kinetic Fury"))
                    //    return "Augmented Blade";
                }
            }
            #endregion

            #region Breaching Strikes
            if (SpellController.CanCast("Breaching Strikes"))
                return "Breaching Strikes";
            #endregion

            #region Atomic Spear
            if (SpellController.CanCast("Atomic Spear"))
                return "Atomic Spear";
            #endregion

            #region Savage Strike
            if (SpellController.CanCast("Savage Strike"))
                return "Savage Strike";
            #endregion

            #region Bolstering Strike
            if (SpellController.CanCast("Bolstering Strike") && Me.InnateResource >= 500)
                return "Bolstering Strike";
            #endregion

            #region Jolt
            if (SpellController.CanCast("Jolt"))
                return "Jolt";
            #endregion

            #region Smackdown
            if (SpellController.CanCast("Smackdown"))
                return "Smackdown";
            #endregion

            #region Rampage
            if (SpellController.CanCast("Rampage"))
            {
                // Kinetic Fury AMP gives damage bonus.
                if (SpellController.HasAMP("Kinetic Fury"))
                {
                    if (Me.InnateResource >= 750)
                        return "Rampage";
                }

                // T8 Rampage gives bonus damage.
                else if (SpellController.Tier("Rampage") >= 8)
                {
                    if (Me.InnateResource >= 500)
                        return "Rampage";
                }

                // No bonuses, use on CD.
                else
                    return "Rampage";
            }
            #endregion

            #region Shield Burst
            if (SpellController.CanCast("Shield Burst") && Me.InnateResource >= 500)
                return "Shield Burst";
            #endregion

            #region Whirlwind
            if (SpellController.CanCast("Whirlwind") && Me.InnateResource > 500)
                return "Whirlwind";
            #endregion

            #region Tremor
            if (SpellController.CanCast("Tremor"))
            {
                // T4 Rampage gets a 3.25s reduction when Tremor is cast.
                if (SpellController.Tier("Rampage") >= 4)
                {
                    if (SpellController.Cooldown("Rampage") > 3250)
                        return "Tremor";
                }

                // No conditions for Tremor, so just use it on CD.
                else
                    return "Tremor";
            }
            #endregion

            #region Relentless Strikes
            if (SpellController.CanCast("Relentless Strikes"))
                return "Relentless Strikes";
            #endregion

            #region Menacing Strike
            if (SpellController.CanCast("Menacing Strike"))
                return "Menacing Strike";
            #endregion

            #endregion

            return null;

            #region Atomic Surge
            #endregion

            #region Polarity Field
            #endregion

            #region Plasma Wall
            #endregion

            #region Expulsion
            #endregion

            #region Defense Grid
            #endregion

            #region Emergency Reserves
            #endregion

            #region Plasma Blast
            #endregion

            #region Unstoppable Force
            #endregion

        }
    }
}
