﻿using Buddy.Wildstar.Game;
using Spell = Buddy.Wildstar.Game.SpellManager.SpellInformation;

namespace Agility
{
    class AgilitySpell
    {
        private Spell spell;

        private bool isValid;
        private string name;
        private int tier;
        private int baseId;
        private int tierId;
        //private int cooldownRemaining
        //private int cooldownFlag;

        public AgilitySpell(string spellName)
        {
            this.spell = SpellManager.GetSpell(spellName);
            this.name = spellName;

            this.isValid = (this.spell != null && this.spell.IsValid);
            if (!this.isValid)
                return;

            this.tier = spell.Tier;
            this.baseId = spell.Ability.SpellId;
            this.tierId = tier == 0 ? this.baseId : GameManager.Lua.GetReturnValue<int>("return AbilityBook.GetAbilityInfo(" + this.baseId + ").tTiers[" + (this.tier+1) + "].splObject:GetId()");
            //this.cooldownRemaining;
            //this.cooldownFlag;
        }

        public int BaseId
        {
            get
            {
                return this.baseId;
            }
        }
        public CastResult CooldownFlags
        {
            get
            {
                return (CastResult)this.spell.CooldownFlags;
            }
        }
        public int CooldownRemaining
        {
            get
            {
                return (int)GameManager.Lua.GetReturnValue<float>("return GameLib.GetSpell(" + this.tierId + "):GetCooldownRemaining()*1000");
            }
        }
        public bool IsValid
        {
            get
            {
                return this.isValid;
            }
        }
        public string Name
        {
            get
            {
                return this.name;
            }
        }
        public int Tier
        {
            get
            {
                return this.tier;
            }
        }
        public int TierId
        {
            get
            {
                return this.tierId;
            }
        }

        public void Cast()
        {
            this.spell.Cast();
        }


    }
}
