﻿using Buddy.Wildstar.Game;
using System.Linq;
using System.Collections.Generic;
using Spell = Buddy.Wildstar.Game.SpellManager.SpellInformation;

namespace Agility
{
    static class SpellCache
    {
        private static List<AgilitySpell> spells = new List<AgilitySpell>();

        public static AgilitySpell GetSpell(string spellName)
        {
            // Check if the spell is already cached, then return it.
            AgilitySpell tmpSpell = spells.FirstOrDefault(s => s.Name == spellName);
            if (tmpSpell != null)
                return tmpSpell;

            // Doesn't exist, add and return.
            tmpSpell = new AgilitySpell(spellName);
            spells.Add(tmpSpell);
            return tmpSpell;
        }

        public static void Refresh()
        {
            spells = new List<AgilitySpell>();
        }

    }

    
}
